Index: sasmodels/models/guinier_porod.py
===================================================================
--- sasmodels/models/guinier_porod.py	(revision a8072067ae8a224e45d23ba71f663aadbe1ba4a9)
+++ sasmodels/models/guinier_porod.py	(revision cdcebf1033e85ca2bb11488372c82a9050ec942a)
@@ -4,5 +4,6 @@
 and dimensionality of scattering objects, including asymmetric objects
 such as rods or platelets, and shapes intermediate between spheres
-and rods or between rods and platelets.
+and rods or between rods and platelets, and overcomes some of the 
+deficiencies of the (Beaucage) Unified_Power_Rg model (see Hammouda, 2010).
 
 Definition
@@ -59,9 +60,8 @@
 ---------
 
-A Guinier, G Fournet, *Small-Angle Scattering of X-Rays*,
-John Wiley and Sons, New York, (1955)
+B Hammouda, *A new Guinier-Porod model, J. Appl. Cryst.*, (2010), 43, 716-719
 
-O Glatter, O Kratky, *Small-Angle X-Ray Scattering*, Academic Press (1982)
-Check out Chapter 4 on Data Treatment, pages 155-156.
+B Hammouda, *Analysis of the Beaucage model, J. Appl. Cryst.*, (2010), 43, 1474-1478
+
 """
 
Index: sasmodels/models/hayter_msa.c
===================================================================
--- sasmodels/models/hayter_msa.c	(revision 0bef47b278e819df7ea6b572375dd7bc9607227e)
+++ sasmodels/models/hayter_msa.c	(revision 4962519cc1910422a467e4f643dba223623e0e09)
@@ -23,9 +23,7 @@
 	double SIdiam, diam, Kappa, cs, IonSt;
 	double  Perm, Beta;
-	double pi, charge;
+	double charge;
 	int ierr;
 	
-	pi = M_PI;
-
 	diam=2*radius_effective;		//in A
 
@@ -38,5 +36,5 @@
 	charge=zz*Elcharge;		//in Coulomb (C)
 	SIdiam = diam*1.0E-10;		//in m
-	Vp=4.0*pi/3.0*(SIdiam/2.0)*(SIdiam/2.0)*(SIdiam/2.0);	//in m^3
+	Vp=M_4PI_3*cube(SIdiam/2.0);	//in m^3
 	cs=csalt*6.022E23*1.0E3;	//# salt molecules/m^3
 	
@@ -50,5 +48,5 @@
 	Kappa=sqrt(2*Beta*IonSt/Perm);     //Kappa calc from Ionic strength
 									   //	Kappa=2/SIdiam					// Use to compare with HP paper
-	gMSAWave[5]=Beta*charge*charge/(pi*Perm*SIdiam*pow((2.0+Kappa*SIdiam),2));
+	gMSAWave[5]=Beta*charge*charge/(M_PI*Perm*SIdiam*square(2.0+Kappa*SIdiam));
 	
 	//         Finally set up dimensionless parameters 
Index: sasmodels/models/hollow_cylinder.c
===================================================================
--- sasmodels/models/hollow_cylinder.c	(revision 0d6e86566d51a1fba22933bdbac8c40d36f9bd76)
+++ sasmodels/models/hollow_cylinder.c	(revision 592343f7d47ec3aad7ffa1ca242acb1346553ede)
@@ -1,4 +1,3 @@
 double form_volume(double radius, double thickness, double length);
-
 double Iq(double q, double radius, double thickness, double length, double sld,
 	double solvent_sld);
@@ -9,107 +8,67 @@
 
 // From Igor library
-static double hollow_cylinder_scaling(
-    double integrand, double delrho, double volume)
+static double
+_hollow_cylinder_scaling(double integrand, double delrho, double volume)
 {
-    double answer;
-    // Multiply by contrast^2
-    answer = integrand*delrho*delrho;
-
-    //normalize by cylinder volume
-    answer *= volume*volume;
-
-    //convert to [cm-1]
-    answer *= 1.0e-4;
-
-    return answer;
+    return 1.0e-4 * square(volume * delrho) * integrand;
 }
 
 
-static double _hollow_cylinder_kernel(
-    double q, double radius, double thickness, double length, double dum)
+static double
+_hollow_cylinder_kernel(double q,
+    double radius, double thickness, double length, double sin_val, double cos_val)
 {
-    const double qs = q*sqrt(1.0-dum*dum);
-    const double lam1 = sas_J1c((radius+thickness)*qs);
-    const double lam2 = sas_J1c(radius*qs);
+    const double qs = q*sin_val;
+    const double lam1 = sas_2J1x_x((radius+thickness)*qs);
+    const double lam2 = sas_2J1x_x(radius*qs);
     const double gamma_sq = square(radius/(radius+thickness));
-    //Note: lim_{r -> r_c} psi = J0(radius_core*qs)
+    //Note: lim_{thickness -> 0} psi = sas_J0(radius*qs)
+    //Note: lim_{radius -> 0} psi = sas_2J1x_x(thickness*qs)
     const double psi = (lam1 - gamma_sq*lam2)/(1.0 - gamma_sq);	//SRK 10/19/00
-    const double t2 = sinc(q*length*dum/2.0);
-    return square(psi*t2);
+    const double t2 = sas_sinx_x(0.5*q*length*cos_val);
+    return psi*t2;
+}
+
+double
+form_volume(double radius, double thickness, double length)
+{
+    double v_shell = M_PI*length*(square(radius+thickness) - radius*radius);
+    return v_shell;
 }
 
 
-static double hollow_cylinder_analytical_2D_scaled(
-    double q, double q_x, double q_y, double radius, double thickness,
-    double length, double sld, double solvent_sld, double theta, double phi)
+double
+Iq(double q, double radius, double thickness, double length,
+    double sld, double solvent_sld)
 {
-    double cyl_x, cyl_y; //, cyl_z
-    //double q_z;
-    double vol, cos_val, delrho;
-    double answer;
-    //convert angle degree to radian
-    theta = theta * M_PI_180;
-    phi = phi * M_PI_180;
-    delrho = solvent_sld - sld;
+    const double lower = 0.0;
+    const double upper = 1.0;		//limits of numerical integral
 
-    // Cylinder orientation
-    cyl_x = sin(theta) * cos(phi);
-    cyl_y = sin(theta) * sin(phi);
-    //cyl_z = -cos(theta) * sin(phi);
+    double summ = 0.0;			//initialize intergral
+    for (int i=0;i<76;i++) {
+        const double cos_val = 0.5*( Gauss76Z[i] * (upper-lower) + lower + upper );
+        const double sin_val = sqrt(1.0 - cos_val*cos_val);
+        const double inter = _hollow_cylinder_kernel(q, radius, thickness, length,
+                                                     sin_val, cos_val);
+        summ += Gauss76Wt[i] * inter * inter;
+    }
 
-    // q vector
-    //q_z = 0;
-
-    // Compute the angle btw vector q and the
-    // axis of the cylinder
-    cos_val = cyl_x*q_x + cyl_y*q_y;// + cyl_z*q_z;
-
-    answer = _hollow_cylinder_kernel(q, radius, thickness, length, cos_val);
-
-    vol = form_volume(radius, thickness, length);
-    answer = hollow_cylinder_scaling(answer, delrho, vol);
-
-    return answer;
+    const double Aq = 0.5*summ*(upper-lower);
+    const double volume = form_volume(radius, thickness, length);
+    return _hollow_cylinder_scaling(Aq, solvent_sld - sld, volume);
 }
 
+double
+Iqxy(double qx, double qy,
+    double radius, double thickness, double length,
+    double sld, double solvent_sld, double theta, double phi)
+{
+    double q, sin_alpha, cos_alpha;
+    ORIENT_SYMMETRIC(qx, qy, theta, phi, q, sin_alpha, cos_alpha);
+    const double Aq = _hollow_cylinder_kernel(q, radius, thickness, length,
+        sin_alpha, cos_alpha);
 
-double form_volume(double radius, double thickness, double length)
-{
-    double v_shell = M_PI*length*((radius+thickness)*(radius+thickness)-radius*radius);
-    return(v_shell);
+    const double vol = form_volume(radius, thickness, length);
+    return _hollow_cylinder_scaling(Aq*Aq, solvent_sld-sld, vol);
 }
 
-
-double Iq(double q, double radius, double thickness, double length,
-    double sld, double solvent_sld)
-{
-    int i;
-    double lower,upper,zi, inter;		//upper and lower integration limits
-    double summ,answer,delrho;			//running tally of integration
-    double norm,volume;	//final calculation variables
-
-    lower = 0.0;
-    upper = 1.0;		//limits of numerical integral
-
-    summ = 0.0;			//initialize intergral
-    for (i=0;i<76;i++) {
-        zi = ( Gauss76Z[i] * (upper-lower) + lower + upper )/2.0;
-        inter = Gauss76Wt[i] * _hollow_cylinder_kernel(q, radius, thickness, length, zi);
-        summ += inter;
-    }
-
-    norm = summ*(upper-lower)/2.0;
-    volume = form_volume(radius, thickness, length);
-    delrho = solvent_sld - sld;
-    answer = hollow_cylinder_scaling(norm, delrho, volume);
-
-    return(answer);
-}
-
-
-double Iqxy(double qx, double qy, double radius, double thickness,
-    double length, double sld, double solvent_sld, double theta, double phi)
-{
-    const double q = sqrt(qx*qx+qy*qy);
-    return hollow_cylinder_analytical_2D_scaled(q, qx/q, qy/q, radius, thickness, length, sld, solvent_sld, theta, phi);
-}
Index: sasmodels/models/hollow_rectangular_prism.c
===================================================================
--- sasmodels/models/hollow_rectangular_prism.c	(revision a8072067ae8a224e45d23ba71f663aadbe1ba4a9)
+++ sasmodels/models/hollow_rectangular_prism.c	(revision 1e7b0db0b7b4315c62b59e1d659332bcbc962b8f)
@@ -2,16 +2,14 @@
 double Iq(double q, double sld, double solvent_sld, double length_a, 
           double b2a_ratio, double c2a_ratio, double thickness);
-double Iqxy(double qx, double qy, double sld, double solvent_sld, 
-            double length_a, double b2a_ratio, double c2a_ratio, double thickness);
 
 double form_volume(double length_a, double b2a_ratio, double c2a_ratio, double thickness)
 {
-    double b_side = length_a * b2a_ratio;
-    double c_side = length_a * c2a_ratio;
+    double length_b = length_a * b2a_ratio;
+    double length_c = length_a * c2a_ratio;
     double a_core = length_a - 2.0*thickness;
-    double b_core = b_side - 2.0*thickness;
-    double c_core = c_side - 2.0*thickness;
+    double b_core = length_b - 2.0*thickness;
+    double c_core = length_c - 2.0*thickness;
     double vol_core = a_core * b_core * c_core;
-    double vol_total = length_a * b_side * c_side;
+    double vol_total = length_a * length_b * length_c;
     double vol_shell = vol_total - vol_core;
     return vol_shell;
@@ -26,90 +24,62 @@
     double thickness)
 {
-    double termA1, termA2, termB1, termB2, termC1, termC2;
+    const double length_b = length_a * b2a_ratio;
+    const double length_c = length_a * c2a_ratio;
+    const double a_half = 0.5 * length_a;
+    const double b_half = 0.5 * length_b;
+    const double c_half = 0.5 * length_c;
+    const double vol_total = length_a * length_b * length_c;
+    const double vol_core = 8.0 * (a_half-thickness) * (b_half-thickness) * (c_half-thickness);
+
+    //Integration limits to use in Gaussian quadrature
+    const double v1a = 0.0;
+    const double v1b = M_PI_2;  //theta integration limits
+    const double v2a = 0.0;
+    const double v2b = M_PI_2;  //phi integration limits
     
-    double b_side = length_a * b2a_ratio;
-    double c_side = length_a * c2a_ratio;
-    double a_half = 0.5 * length_a;
-    double b_half = 0.5 * b_side;
-    double c_half = 0.5 * c_side;
+    double outer_sum = 0.0;
+    for(int i=0; i<76; i++) {
 
-   //Integration limits to use in Gaussian quadrature
-    double v1a = 0.0;
-    double v1b = 0.5 * M_PI;  //theta integration limits
-    double v2a = 0.0;
-    double v2b = 0.5 * M_PI;  //phi integration limits
-    
-    //Order of integration
-    int nordi=76;			        
-    int nordj=76;
+        const double theta = 0.5 * ( Gauss76Z[i]*(v1b-v1a) + v1a + v1b );
+        double sin_theta, cos_theta;
+        SINCOS(theta, sin_theta, cos_theta);
 
-    double sumi = 0.0;
-    
-    for(int i=0; i<nordi; i++) {
+        const double termC1 = sas_sinx_x(q * c_half * cos(theta));
+        const double termC2 = sas_sinx_x(q * (c_half-thickness)*cos(theta));
 
-	    double theta = 0.5 * ( Gauss76Z[i]*(v1b-v1a) + v1a + v1b );	
+        double inner_sum = 0.0;
+        for(int j=0; j<76; j++) {
 
-	    double arg = q * c_half * cos(theta);
-	    if (fabs(arg) > 1.e-16) {termC1 = sin(arg)/arg;} else {termC1 = 1.0;}
-	    arg = q * (c_half-thickness)*cos(theta);
-	    if (fabs(arg) > 1.e-16) {termC2 = sin(arg)/arg;} else {termC2 = 1.0;}
-
-	    double sumj = 0.0;
-        
-	    for(int j=0; j<nordj; j++) {
-
-            double phi = 0.5 * ( Gauss76Z[j]*(v2b-v2a) + v2a + v2b ); 
+            const double phi = 0.5 * ( Gauss76Z[j]*(v2b-v2a) + v2a + v2b );
+            double sin_phi, cos_phi;
+            SINCOS(phi, sin_phi, cos_phi);
 
             // Amplitude AP from eqn. (13), rewritten to avoid round-off effects when arg=0
 
-	        arg = q * a_half * sin(theta) * sin(phi);
-	        if (fabs(arg) > 1.e-16) {termA1 = sin(arg)/arg;} else {termA1 = 1.0;}
-	        arg = q * (a_half-thickness) * sin(theta) * sin(phi);
-	        if (fabs(arg) > 1.e-16) {termA2 = sin(arg)/arg;} else {termA2 = 1.0;}
+            const double termA1 = sas_sinx_x(q * a_half * sin_theta * sin_phi);
+            const double termA2 = sas_sinx_x(q * (a_half-thickness) * sin_theta * sin_phi);
 
-	        arg = q * b_half * sin(theta) * cos(phi);
-	        if (fabs(arg) > 1.e-16) {termB1 = sin(arg)/arg;} else {termB1 = 1.0;}
-	        arg = q * (b_half-thickness) * sin(theta) * cos(phi);
-	        if (fabs(arg) > 1.e-16) {termB2 = sin(arg)/arg;} else {termB2 = 1.0;}
+            const double termB1 = sas_sinx_x(q * b_half * sin_theta * cos_phi);
+            const double termB2 = sas_sinx_x(q * (b_half-thickness) * sin_theta * cos_phi);
 
-            double AP1 = (length_a*b_side*c_side) * termA1 * termB1 * termC1;
-            double AP2 = 8.0 * (a_half-thickness) * (b_half-thickness) * (c_half-thickness) * termA2 * termB2 * termC2;
-            double AP = AP1 - AP2;
+            const double AP1 = vol_total * termA1 * termB1 * termC1;
+            const double AP2 = vol_core * termA2 * termB2 * termC2;
 
-	        sumj += Gauss76Wt[j] * (AP*AP);
+            inner_sum += Gauss76Wt[j] * square(AP1-AP2);
+        }
+        inner_sum *= 0.5 * (v2b-v2a);
 
-	    }
-
-	    sumj = 0.5 * (v2b-v2a) * sumj;
-	    sumi += Gauss76Wt[i] * sumj * sin(theta);
-
+        outer_sum += Gauss76Wt[i] * inner_sum * sin(theta);
     }
-
-    double answer = 0.5*(v1b-v1a)*sumi;
+    outer_sum *= 0.5*(v1b-v1a);
 
     // Normalize as in Eqn. (15) without the volume factor (as cancels with (V*DelRho)^2 normalization)
     // The factor 2 is due to the different theta integration limit (pi/2 instead of pi)
-    answer *= (2.0/M_PI);
+    const double form = outer_sum/M_PI_2;
 
     // Multiply by contrast^2. Factor corresponding to volume^2 cancels with previous normalization.
-    answer *= (sld-solvent_sld)*(sld-solvent_sld);
+    const double delrho = sld - solvent_sld;
 
     // Convert from [1e-12 A-1] to [cm-1]
-    answer *= 1.0e-4;
-
-    return answer;
-    
+    return 1.0e-4 * delrho * delrho * form;
 }
-
-double Iqxy(double qx, double qy,
-    double sld,
-    double solvent_sld,
-    double length_a,
-    double b2a_ratio,
-    double c2a_ratio,
-    double thickness)
-{
-    double q = sqrt(qx*qx + qy*qy);
-    double intensity = Iq(q, sld, solvent_sld, length_a, b2a_ratio, c2a_ratio, thickness); 
-    return intensity;    
-}
Index: sasmodels/models/hollow_rectangular_prism.py
===================================================================
--- sasmodels/models/hollow_rectangular_prism.py	(revision a8072067ae8a224e45d23ba71f663aadbe1ba4a9)
+++ sasmodels/models/hollow_rectangular_prism.py	(revision ab2aea81f7fb392e5f24f1c76dd989914d8f7022)
@@ -13,5 +13,5 @@
 the difference of the amplitudes of two massive parallelepipeds
 differing in their outermost dimensions in each direction by the
-same length increment :math:`2\Delta` (Nayuk, 2012).
+same length increment $2\Delta$ (Nayuk, 2012).
 
 As in the case of the massive parallelepiped model (:ref:`rectangular-prism`),
@@ -58,9 +58,9 @@
 
 .. math::
-  I(q) = \text{scale} \times V \times (\rho_{\text{p}} -
-  \rho_{\text{solvent}})^2 \times P(q) + \text{background}
+  I(q) = \text{scale} \times V \times (\rho_\text{p} -
+  \rho_\text{solvent})^2 \times P(q) + \text{background}
 
-where $\rho_{\text{p}}$ is the scattering length of the parallelepiped,
-$\rho_{\text{solvent}}$ is the scattering length of the solvent,
+where $\rho_\text{p}$ is the scattering length of the parallelepiped,
+$\rho_\text{solvent}$ is the scattering length of the solvent,
 and (if the data are in absolute units) *scale* represents the volume fraction
 (which is unitless).
@@ -148,5 +148,5 @@
 # parameters for demo
 demo = dict(scale=1, background=0,
-            sld=6.3e-6, sld_solvent=1.0e-6,
+            sld=6.3, sld_solvent=1.0,
             length_a=35, b2a_ratio=1, c2a_ratio=1, thickness=1,
             length_a_pd=0.1, length_a_pd_n=10,
Index: sasmodels/models/hollow_rectangular_prism_thin_walls.c
===================================================================
--- sasmodels/models/hollow_rectangular_prism_thin_walls.c	(revision a8072067ae8a224e45d23ba71f663aadbe1ba4a9)
+++ sasmodels/models/hollow_rectangular_prism_thin_walls.c	(revision ab2aea81f7fb392e5f24f1c76dd989914d8f7022)
@@ -2,12 +2,10 @@
 double Iq(double q, double sld, double solvent_sld, double length_a, 
           double b2a_ratio, double c2a_ratio);
-double Iqxy(double qx, double qy, double sld, double solvent_sld, 
-            double length_a, double b2a_ratio, double c2a_ratio);
 
 double form_volume(double length_a, double b2a_ratio, double c2a_ratio)
 {
-    double b_side = length_a * b2a_ratio;
-    double c_side = length_a * c2a_ratio;
-    double vol_shell = 2.0 * (length_a*b_side + length_a*c_side + b_side*c_side);
+    double length_b = length_a * b2a_ratio;
+    double length_c = length_a * c2a_ratio;
+    double vol_shell = 2.0 * (length_a*length_b + length_a*length_c + length_b*length_c);
     return vol_shell;
 }
@@ -20,61 +18,63 @@
     double c2a_ratio)
 {
-    double b_side = length_a * b2a_ratio;
-    double c_side = length_a * c2a_ratio;
-    double a_half = 0.5 * length_a;
-    double b_half = 0.5 * b_side;
-    double c_half = 0.5 * c_side;
+    const double length_b = length_a * b2a_ratio;
+    const double length_c = length_a * c2a_ratio;
+    const double a_half = 0.5 * length_a;
+    const double b_half = 0.5 * length_b;
+    const double c_half = 0.5 * length_c;
 
    //Integration limits to use in Gaussian quadrature
-    double v1a = 0.0;
-    double v1b = 0.5 * M_PI;  //theta integration limits
-    double v2a = 0.0;
-    double v2b = 0.5 * M_PI;  //phi integration limits
+    const double v1a = 0.0;
+    const double v1b = M_PI_2;  //theta integration limits
+    const double v2a = 0.0;
+    const double v2b = M_PI_2;  //phi integration limits
     
-    //Order of integration
-    int nordi=76;			        
-    int nordj=76;
+    double outer_sum = 0.0;
+    for(int i=0; i<76; i++) {
+        const double theta = 0.5 * ( Gauss76Z[i]*(v1b-v1a) + v1a + v1b );
 
-    double sumi = 0.0;
-    
-    for(int i=0; i<nordi; i++) {
+        double sin_theta, cos_theta;
+        double sin_c, cos_c;
+        SINCOS(theta, sin_theta, cos_theta);
+        SINCOS(q*c_half*cos_theta, sin_c, cos_c);
 
-	    double theta = 0.5 * ( Gauss76Z[i]*(v1b-v1a) + v1a + v1b );	
-        
         // To check potential problems if denominator goes to zero here !!!
-        double termAL_theta = 8.0*cos(q*c_half*cos(theta)) / (q*q*sin(theta)*sin(theta));
-        double termAT_theta = 8.0*sin(q*c_half*cos(theta)) / (q*q*sin(theta)*cos(theta));
+        const double termAL_theta = 8.0 * cos_c / (q*q*sin_theta*sin_theta);
+        const double termAT_theta = 8.0 * sin_c / (q*q*sin_theta*cos_theta);
 
-	    double sumj = 0.0;
-        
-	    for(int j=0; j<nordj; j++) {
+        double inner_sum = 0.0;
+        for(int j=0; j<76; j++) {
+            const double phi = 0.5 * ( Gauss76Z[j]*(v2b-v2a) + v2a + v2b );
 
-            double phi = 0.5 * ( Gauss76Z[j]*(v2b-v2a) + v2a + v2b ); 
-            
+            double sin_phi, cos_phi;
+            double sin_a, cos_a;
+            double sin_b, cos_b;
+            SINCOS(phi, sin_phi, cos_phi);
+            SINCOS(q*a_half*sin_theta*sin_phi, sin_a, cos_a);
+            SINCOS(q*b_half*sin_theta*cos_phi, sin_b, cos_b);
+
             // Amplitude AL from eqn. (7c)
-            double AL = termAL_theta * sin(q*a_half*sin(theta)*sin(phi)) * 
-                sin(q*b_half*sin(theta)*cos(phi)) / (sin(phi)*cos(phi));
+            const double AL = termAL_theta
+                * sin_a*sin_b / (sin_phi*cos_phi);
 
             // Amplitude AT from eqn. (9)
-            double AT = termAT_theta * (  (cos(q*a_half*sin(theta)*sin(phi))*sin(q*b_half*sin(theta)*cos(phi))/cos(phi)) 
-                + (cos(q*b_half*sin(theta)*cos(phi))*sin(q*a_half*sin(theta)*sin(phi))/sin(phi)) );
+            const double AT = termAT_theta
+                * ( cos_a*sin_b/cos_phi + cos_b*sin_a/sin_phi );
 
-            sumj += Gauss76Wt[j] * (AL+AT)*(AL+AT);
+            inner_sum += Gauss76Wt[j] * square(AL+AT);
+        }
 
-	    }
-
-	    sumj = 0.5 * (v2b-v2a) * sumj;
-	    sumi += Gauss76Wt[i] * sumj * sin(theta);
-
+        inner_sum *= 0.5 * (v2b-v2a);
+        outer_sum += Gauss76Wt[i] * inner_sum * sin_theta;
     }
 
-    double answer = 0.5*(v1b-v1a)*sumi;
+    outer_sum *= 0.5*(v1b-v1a);
 
     // Normalize as in Eqn. (15) without the volume factor (as cancels with (V*DelRho)^2 normalization)
     // The factor 2 is due to the different theta integration limit (pi/2 instead of pi)
-    answer *= (2.0/M_PI);
+    double answer = outer_sum/M_PI_2;
 
     // Multiply by contrast^2. Factor corresponding to volume^2 cancels with previous normalization.
-    answer *= (sld-solvent_sld)*(sld-solvent_sld);
+    answer *= square(sld-solvent_sld);
 
     // Convert from [1e-12 A-1] to [cm-1]
@@ -82,16 +82,3 @@
 
     return answer;
-    
 }
-
-double Iqxy(double qx, double qy,
-    double sld,
-    double solvent_sld,
-    double length_a,
-    double b2a_ratio,
-    double c2a_ratio)
-{
-    double q = sqrt(qx*qx + qy*qy);
-    double intensity = Iq(q, sld, solvent_sld, length_a, b2a_ratio, c2a_ratio); 
-    return intensity;    
-}
Index: sasmodels/models/hollow_rectangular_prism_thin_walls.py
===================================================================
--- sasmodels/models/hollow_rectangular_prism_thin_walls.py	(revision a8072067ae8a224e45d23ba71f663aadbe1ba4a9)
+++ sasmodels/models/hollow_rectangular_prism_thin_walls.py	(revision ab2aea81f7fb392e5f24f1c76dd989914d8f7022)
@@ -3,5 +3,5 @@
 r"""
 
-This model provides the form factor, *P(q)*, for a hollow rectangular
+This model provides the form factor, $P(q)$, for a hollow rectangular
 prism with infinitely thin walls. It computes only the 1D scattering, not the 2D.
 
@@ -14,36 +14,37 @@
 
 Assuming a hollow parallelepiped with infinitely thin walls, edge lengths
-:math:`A \le B \le C` and presenting an orientation with respect to the
-scattering vector given by |theta| and |phi|, where |theta| is the angle
-between the *z* axis and the longest axis of the parallelepiped *C*, and
-|phi| is the angle between the scattering vector (lying in the *xy* plane)
-and the *y* axis, the form factor is given by
+$A \le B \le C$ and presenting an orientation with respect to the
+scattering vector given by $\theta$ and $\phi$, where $\theta$ is the angle
+between the $z$ axis and the longest axis of the parallelepiped $C$, and
+$\phi$ is the angle between the scattering vector (lying in the $xy$ plane)
+and the $y$ axis, the form factor is given by
 
 .. math::
-  P(q) =  \frac{1}{V^2} \frac{2}{\pi} \int_0^{\frac{\pi}{2}}
-  \int_0^{\frac{\pi}{2}} [A_L(q)+A_T(q)]^2 \sin\theta d\theta d\phi
+
+    P(q) = \frac{1}{V^2} \frac{2}{\pi} \int_0^{\frac{\pi}{2}}
+           \int_0^{\frac{\pi}{2}} [A_L(q)+A_T(q)]^2 \sin\theta\,d\theta\,d\phi
 
 where
 
 .. math::
-  V = 2AB + 2AC + 2BC
 
-.. math::
-  A_L(q) =  8 \times \frac{ \sin \bigl( q \frac{A}{2} \sin\phi \sin\theta \bigr)
-                              \sin \bigl( q \frac{B}{2} \cos\phi \sin\theta \bigr)
-                              \cos \bigl( q \frac{C}{2} \cos\theta \bigr) }
-                            {q^2 \, \sin^2\theta \, \sin\phi \cos\phi}
-
-.. math::
-  A_T(q) =  A_F(q) \times \frac{2 \, \sin \bigl( q \frac{C}{2} \cos\theta \bigr)}{q \, \cos\theta}
+    V &= 2AB + 2AC + 2BC \\
+    A_L(q) &=  8 \times \frac{
+            \sin \left( \tfrac{1}{2} q A \sin\phi \sin\theta \right)
+            \sin \left( \tfrac{1}{2} q B \cos\phi \sin\theta \right)
+            \cos \left( \tfrac{1}{2} q C \cos\theta \right)
+        }{q^2 \, \sin^2\theta \, \sin\phi \cos\phi} \\
+    A_T(q) &=  A_F(q) \times
+      \frac{2\,\sin \left( \tfrac{1}{2} q C \cos\theta \right)}{q\,\cos\theta}
 
 and
 
 .. math::
-  A_F(q) =  4 \frac{ \cos \bigl( q \frac{A}{2} \sin\phi \sin\theta \bigr)
-                       \sin \bigl( q \frac{B}{2} \cos\phi \sin\theta \bigr) }
+
+  A_F(q) =  4 \frac{ \cos \left( \tfrac{1}{2} q A \sin\phi \sin\theta \right)
+                       \sin \left( \tfrac{1}{2} q B \cos\phi \sin\theta \right) }
                      {q \, \cos\phi \, \sin\theta} +
-              4 \frac{ \sin \bigl( q \frac{A}{2} \sin\phi \sin\theta \bigr)
-                       \cos \bigl( q \frac{B}{2} \cos\phi \sin\theta \bigr) }
+              4 \frac{ \sin \left( \tfrac{1}{2} q A \sin\phi \sin\theta \right)
+                       \cos \left( \tfrac{1}{2} q B \cos\phi \sin\theta \right) }
                      {q \, \sin\phi \, \sin\theta}
 
@@ -51,8 +52,9 @@
 
 .. math::
-  I(q) = \mbox{scale} \times V \times (\rho_{\mbox{p}} - \rho_{\mbox{solvent}})^2 \times P(q)
 
-where *V* is the volume of the rectangular prism, :math:`\rho_{\mbox{p}}`
-is the scattering length of the parallelepiped, :math:`\rho_{\mbox{solvent}}`
+  I(q) = \text{scale} \times V \times (\rho_\text{p} - \rho_\text{solvent})^2 \times P(q)
+
+where $V$ is the volume of the rectangular prism, $\rho_\text{p}$
+is the scattering length of the parallelepiped, $\rho_\text{solvent}$
 is the scattering length of the solvent, and (if the data are in absolute
 units) *scale* represents the volume fraction (which is unitless).
@@ -127,5 +129,5 @@
 # parameters for demo
 demo = dict(scale=1, background=0,
-            sld=6.3e-6, sld_solvent=1.0e-6,
+            sld=6.3, sld_solvent=1.0,
             length_a=35, b2a_ratio=1, c2a_ratio=1,
             length_a_pd=0.1, length_a_pd_n=10,
Index: sasmodels/models/lamellar_stack_paracrystal.c
===================================================================
--- sasmodels/models/lamellar_stack_paracrystal.c	(revision 0bef47b278e819df7ea6b572375dd7bc9607227e)
+++ sasmodels/models/lamellar_stack_paracrystal.c	(revision 4962519cc1910422a467e4f643dba223623e0e09)
@@ -67,5 +67,5 @@
 	double Snq;
 
-	Snq = an/( (double)Nlayers*pow((1.0+ww*ww-2.0*ww*cos(qval*davg)),2) );
+	Snq = an/( (double)Nlayers*square(1.0+ww*ww-2.0*ww*cos(qval*davg)) );
 	
 	return(Snq);
Index: sasmodels/models/lib/core_shell.c
===================================================================
--- sasmodels/models/lib/core_shell.c	(revision 7d4b2ae2af901813f3ff60e60aa0eae98f4dfd5e)
+++ sasmodels/models/lib/core_shell.c	(revision 925ad6edca2969db8fb763eb02beee2c5a5f2872)
@@ -16,6 +16,6 @@
     const double core_qr = q * radius;
     const double core_contrast = core_sld - shell_sld;
-    const double core_bes = sph_j1c(core_qr);
-    const double core_volume = 4.0 * M_PI / 3.0 * radius * radius * radius;
+    const double core_bes = sas_3j1x_x(core_qr);
+    const double core_volume = M_4PI_3 * cube(radius);
     double f = core_volume * core_bes * core_contrast;
 
@@ -23,6 +23,6 @@
     const double shell_qr = q * (radius + thickness);
     const double shell_contrast = shell_sld - solvent_sld;
-    const double shell_bes = sph_j1c(shell_qr);
-    const double shell_volume = 4.0 * M_PI / 3.0 * pow((radius + thickness), 3);
+    const double shell_bes = sas_3j1x_x(shell_qr);
+    const double shell_volume = M_4PI_3 * cube(radius + thickness);
     f += shell_volume * shell_bes * shell_contrast;
     return f * f * 1.0e-4;
Index: sasmodels/models/lib/fractal_sq.c
===================================================================
--- sasmodels/models/lib/fractal_sq.c	(revision 217590bce5ffcf2c4de704a4770a9cab003dd287)
+++ sasmodels/models/lib/fractal_sq.c	(revision 217590bce5ffcf2c4de704a4770a9cab003dd287)
@@ -0,0 +1,28 @@
+static double
+fractal_sq(double q, double radius, double fractal_dim, double cor_length)
+{
+    //calculate S(q),  using Teixeira, Eq(15)
+    // mathematica query to check limiting conditions:
+    //    lim x->0 of [ x gamma(x-1) sin(arctan(q c (x-1))) (q r)^(-x) (1 + 1/(q c)^2)^((1-x)/2) ]
+    // Note: gamma(x) may be unreliable for x<0, so the gamma(D-1) is risky.
+    // We instead transform D*gamma(D-1) into gamma(D+1)/(D-1).
+    double term;
+    if (q == 0.) {
+        const double D = fractal_dim;
+        term = pow(cor_length/radius, D)*sas_gamma(D+1.);
+    } else if (fractal_dim == 0.) {
+        term = 1.0;
+    } else if (fractal_dim == 1.) {
+        term = atan(q*cor_length)/(q*radius);
+    } else {
+        // q>0, D>0
+        const double D = fractal_dim;
+        const double Dm1 = fractal_dim - 1.0;
+        // Note: for large Dm1, sin(Dm1*atan(q*cor_length) can go negative
+        const double t1 = sas_gamma(D+1.)/Dm1*sin(Dm1*atan(q*cor_length));
+        const double t2 = pow(q*radius, -D);
+        const double t3 = pow(1.0 + 1.0/square(q*cor_length), -0.5*Dm1);
+        term = t1 * t2 * t3;
+    }
+    return 1.0 + term;
+}
Index: sasmodels/models/lib/gfn.c
===================================================================
--- sasmodels/models/lib/gfn.c	(revision 177c1a138481a9833b4929af687e86583b5c16d5)
+++ sasmodels/models/lib/gfn.c	(revision 925ad6edca2969db8fb763eb02beee2c5a5f2872)
@@ -12,5 +12,4 @@
 {
     // local variables
-    const double pi43=4.0/3.0*M_PI;
     const double aa = crmaj;
     const double bb = crmin;
@@ -19,13 +18,13 @@
     // changing to more accurate sph_j1c since the following inexplicably fails on Radeon Nano.
     //const double siq = (uq == 0.0 ? 1.0 : 3.0*(sin(uq)/uq/uq - cos(uq)/uq)/uq);
-    const double siq = sph_j1c(uq);
-    const double vc = pi43*aa*aa*bb;
+    const double siq = sas_3j1x_x(uq);
+    const double vc = M_4PI_3*aa*aa*bb;
     const double gfnc = siq*vc*delpc;
 
     const double ut2 = (trmin*trmin*xx*xx + trmaj*trmaj*(1.0-xx*xx));
     const double ut= sqrt(ut2)*qq;
-    const double vt = pi43*trmaj*trmaj*trmin;
+    const double vt = M_4PI_3*trmaj*trmaj*trmin;
     //const double sit = (ut == 0.0 ? 1.0 : 3.0*(sin(ut)/ut/ut - cos(ut)/ut)/ut);
-    const double sit = sph_j1c(ut);
+    const double sit = sas_3j1x_x(ut);
     const double gfnt = sit*vt*delps;
 
@@ -33,4 +32,4 @@
     const double result = tgfn*tgfn;
 
-    return (result);
+    return result;
 }
Index: sasmodels/models/lib/polevl.c
===================================================================
--- sasmodels/models/lib/polevl.c	(revision 0278e3fec71d4a97458c09903fd5e3bd354166c1)
+++ sasmodels/models/lib/polevl.c	(revision 447e9aab67fe022330aad0a4c8873028603d4b87)
@@ -28,5 +28,5 @@
  *            N                   0
  *
- *  The function p1evl() assumes that coef[N] = 1.0 and is
+ * The function p1evl() assumes that C_N = 1.0 and is
  * omitted from the array.  Its calling arguments are
  * otherwise the same as polevl().
